You Are the One
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3303 Accepted Submission(s): 1492
Problem Description
The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?
Input
The first line contains a single integer T, the number of test cases. For each case, the first line is n (0 < n <= 100)
The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)
Output
For each test case, output the least summary of unhappiness .
Sample Input
2
5
1
2
3
4
5
5
5
4
3
2
2
Sample Output
Case #1: 20
Case #2: 24
Source
2012 ACM/ICPC Asia Regional Tianjin Online
这是一道区间dp题。我们用dp[i][j]表示第i个人到第j个人unhappiness总和的最小值,因此dp[1][n]就是我们所要求的的值。怎么求呢?这种题肯定是转换成一些子问题,不断地的递推求解。我们来考虑第i个人的情况,在区间[i,j]中,第i个人可能是第一个走的,也可能是第j-i+1 个走的,所以假设第i个人是第k个走的,根据题目有第i 个人的这里写代码片unhappiness值为(k-1)D[i].那么从i+1 开始的k-1个人都是在i 之前走的,此时就会出现一个子问题——dp[i+1][i+1+k-1+1].这个区间的人都是已经走过的,那么在[i,j] 区间里,从i+k到j 都是还没有走的,那么他们就要继续等待,把它们看成一个整体,即unhappyiness 值为k(sum[j]-sum[i+k-1]).
根据这个思路,代码如下:
#include<stdio.h>
#include<string.h>
#define INF 0x3f3f3f3f
int min(int a,int b)
{
return a<b?a:b;
}
int main()
{
int D[105],dp[105][105],i,j,T,n,sum[105],len,t=1,k;
scanf("%d",&T);//案列数
while(T--)
{
scanf("%d",&n);//人数
sum[0]=0;
memset(dp,0,sizeof(dp));
for(i=1;i<=n;i++)
{
scanf("%d",&D[i]);
sum[i]=sum[i-1]+D[i];//所有人的unhappiness 和
}
for(i=0;i<105;i++)
for(j=i+1;j<105;j++)
dp[i][j]=INF;//dp数组初始化,全部赋值为无穷大,因为dp存放的是最小值
for(len=2;len<=n;len++)//为了改变j的值
for(i=1;i+len-1<=n;i++)//设定区间[i,j]
{
j=i+len-1;
for(k=1;k<=len;k++)//设定i 是第k个出去
dp[i][j]=min(dp[i][j],dp[i+1][i+k-1]+(k-1)*D[i]+k*(sum[j]-sum[i+k-1])+dp[i+k][j]);
}
printf("Case #%d: %d\n",t++,dp[1][n]);
}
return 0;
}